+++
title="Aerogramme in the modern email track at FOSDEM'24"
date=2024-02-05
+++

*FOSDEM is the European conference for FLOSS developpers. It was the first time Aerogramme was discussed publicly.
If you missed the presentation, a recording and the slides are available.*

<!-- more -->

---

## Recording

<div class="video">
  <video controls="controls" width="75%">
    <source src="https://video.fosdem.org/2024/h2213/fosdem-2024-2642--servers-aerogramme-a-multi-region-imap-server.av1.webm" type="video/webm; codecs=&quot;av01.0.08M.08.0.110.01.01.01.0&quot;">
    <source src="https://video.fosdem.org/2024/h2213/fosdem-2024-2642--servers-aerogramme-a-multi-region-imap-server.mp4" type="video/mp4">
  </video>
</div>

## Transcript

*(slide 1)* Aerogramme is a multi-region IMAP server, in this talk we will discuss what a "multi-region IMAP server" means and why it's important.

*(slide 2)*
Let's start with some context, my name is Quentin. I have a PhD in distributed system,
and this talk will be a lot about PhD distributed system because something I know.
I try to work as much as possible for a collective named Deuxfleurs where we try to build a low-tech Internet.
If you want to know more about our project, check yesterday talk about Garage.
Aerogramme is part of Deuxfleurs' strategy, and a very nice thing, this project is supported by NLnet.

*(slide 3)*
First, the problem we want to solve: we want to make other people available when it would be otherwise
impossible (due to geographical distances for example). We can achieve this goal only if the underlying system is working:
so we will talk a lot about availability and reliability.

*(slide 4)*
Today's talk is about 3 main ideas: 1) we should not trust the cloud & hosting providers as they can fail. 2) there is some space to explore alternative IMAP server designs and 3) and finally I will try to convince you that such new designs can work in the real life

*(slide 5)*
In the title talk, I speak about "multi-region", and so we must define first what is a "region".
On the slide is depicted the Google Cloud Platform (GCP) region in Paris: it's made of 3 datacenters.
Last april, the whole region, the 3 datacenters were unavailable for 3 weeks.
The outage lasted for 3 weeks for some services, and it was due to a fire in one datacenter.
And due to tight connections between the 3 datacenters, the 2 others ones were unusable due to a software problem.
3 weeks without emails, you imagine it can make your life very hard if you need to do some important stuff, like seeking a new job.

*(rest of the transcript is missing currently)*

## Links

 - [Download Slides](https://fosdem.org/2024/events/attachments/fosdem-2024-2642--servers-aerogramme-a-multi-region-imap-server/slides/22665/aerogramme_vmnrj3Q.pdf)
 - [Aerogramme Talk Page](https://fosdem.org/2024/schedule/event/fosdem-2024-2642--servers-aerogramme-a-multi-region-imap-server/)
 - [Modern Email Track](https://fosdem.org/2024/schedule/track/modern-email/)
 - [2024 edition main page](https://fosdem.org/2024/)

